/*
 * gsampler-instrument.h
 * Copyright (C) Lilian Monchalin 2011 <isaya07@users.sf.net>
 * 
 * gsampler is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * gsampler is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GSAMPLER_INSTRUMENT_H_
#define _GSAMPLER_INSTRUMENT_H_

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define GSAMPLER_TYPE_INSTRUMENT (gsampler_instrument_get_type ())
#define GSAMPLER_INSTRUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GSAMPLER_TYPE_INSTRUMENT, GsamplerInstrument))
#define GSAMPLER_INSTRUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GSAMPLER_TYPE_INSTRUMENT, GsamplerInstrumentClass))
#define GSAMPLER_IS_INSTRUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GSAMPLER_TYPE_INSTRUMENT))
#define GSAMPLER_IS_INSTRUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GSAMPLER_TYPE_INSTRUMENT))
#define GSAMPLER_INSTRUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GSAMPLER_TYPE_INSTRUMENT, GsamplerInstrumentClass))
#define GSAMPLER_INSTRUMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GSAMPLER_TYPE_INSTRUMENT, GsamplerInstrumentPrivate))

typedef struct _GsamplerInstrument GsamplerInstrument;
typedef struct _GsamplerInstrumentClass GsamplerInstrumentClass;
typedef struct _GsamplerInstrumentPrivate GsamplerInstrumentPrivate;

struct _GsamplerInstrument {
	GObject parent_instance;
	GsamplerInstrumentPrivate * priv;
};

struct _GsamplerInstrumentClass {
	GObjectClass parent_class;
};

struct _GsamplerInstrumentPrivate {
	gint channel;
	gchar* file;
	gint id;
	GSList *inst_list;
};

GType 				gsampler_instrument_get_type (void) G_GNUC_CONST;
GsamplerInstrument* gsampler_instrument_new (void);
gboolean 			gsampler_instrument_load_file (GsamplerInstrument* self, const gchar* file_name);
gchar* 				gsampler_instrument_get_file (GsamplerInstrument* self);
gchar* 				gsampler_instrument_get_name (GsamplerInstrument* self, gint id);
GSList* 			gsampler_instrument_get_list (GsamplerInstrument* self);

G_END_DECLS

#endif /* _GSAMPLER_INSTRUMENT_H_ */